#!/bin/bash
#
# Component: cases
#
# Description:
#
# Usage:
#   checkLockedUsers
#

. $HOME/etc/setenv.sh

#we have to do it in 2 steps because of the logging :(

echo "checking locked users"
now=`date +%s`
echo "now:"$now
# condition USERACTUALUNLOCK != 0 means that the failed attempt lock is NOT permanent
# condition USERLOCKEDSINCE != 0 means that the lock is NOT manual (manual locks are always permanent and should not be automatically unlocked)
query="select USERID from Access where USERLOCKED='yes' and USERACTUALUNLOCK != 0 and USERLOCKEDSINCE != 0 and $now>=USERLOCKEDSINCE+USERACTUALUNLOCK*60"
echo $query
res=$( ${TOOLS_HOME}/sql.sh "$query" -N )
if [ $? -ne 0 ] ; then 
	echo $res
	echo "PROBLEM!!! exiting"
	exit 1
else
	echo $res
fi
inclause=""
if [ ! -z "$res" ] ; then
	for user in $res ; do
		inclause="${inclause},'$user'"
		#log here with $user
		$LOG_HOME/logintodatabase.sh -p "INFO" -l "ADMIN" -a "userAUTOUNLOCK" -u "system" -m "User ${user} has been auto-unlocked" 
	done
	inclause=${inclause#","}
	echo $inclause
	update1="delete from FailedLogin where FLUSERID in ($inclause)"
	echo $update1
	${TOOLS_HOME}/sql.sh "$update1" -N
	
	update2="update Access set USERLOCKED='no' where USERID in ($inclause)"
	echo $update2
	${TOOLS_HOME}/sql.sh "$update2" -N
fi
