<%--
 * Component: cases
 *
 * Description:
 *    Performs daily tasks: purges old studies and orders.
 *
 * Params:
 *   f - pathinfo : looks like <study><fname>_<frame>[.<size>[w|t]].<ext>
 *                  9.8.7.6/CT.1.2.3.4.5_1[.size[w|t]].ext
 *  [cTargetDevice] - needs redirect to the direction of this device instead of usual
 *
 *   Thin viewer related options:
 *   x - x coordinate of topleft (?) corner of the segment to return
 *   y - y coordinate of topleft (?) corner of the segment to return
 *   w - width of the segment
 *   h - height of the segment
 * 
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@page import="com.erad.pacs.toolbox.UserRequestResponseToolbox"%>
<%@page import="imagemed.dcprocessing.Herpa"%>
<%@page import="cases.FramejspKeystoreParam"%>
<%@page import="com.erad.pacs.services.usermanager.client.Envelope"%>
<%@page import="com.erad.pacs.toolbox.LoginServiceToolbox"%>
<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.SessionException"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.modules.gwt.datastructure.usermanager.RequestConsts"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.dotcom.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.dcprocessing.Frame,
			imagemed.http.Range, imagemed.util.*, java.io.*, java.util.concurrent.TimeoutException, java.lang.Exception" %>
<%@ page trimDirectiveWhitespaces="true" %>
<%!

%><%
	String referrerHost = request.getParameter( "ReferrerHost" );

	if ( referrerHost != null ) {
		response.setHeader( "Access-Control-Allow-Origin", referrerHost );
	}
	Session sess;
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	// check and allow localhost calls
	
	try {
		sess = UserRequestResponseToolbox.getSessitaSessionNoSessParCheck( request, response );
	} 
	catch ( SessionException se ) {
		if ( LoginServiceToolbox.checkServerIp( request.getRemoteAddr() ) ) {
			String user = request.getParameter( "cActingUser" );
			Envelope userEnvelope = null;
			try {
				userEnvelope = LoginServiceToolbox.loginService(userManager, new FramejspKeystoreParam(), user);
			}
			catch ( Exception e ) {
				Helper.ERRORLOG( "reportview.jsp", "Login failed: " + e.getMessage(  )  );
				return;
			}
			sess = UserRequestResponseToolbox.checkEnvelope( request, response, userEnvelope );
		}
		else {
			throw se;
		}
	}

	//UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	//Session sess = userManager.getSessitaSessionNoSessParCheck( request, response );

	//IMSession is = new IMSession( request, response, out );
	Syslog logger = new Syslog( "frame", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );

	boolean bCheckHttpsAndRedirect = false;
	if ( ! ProxyToolbox.init( sess, null, logger ) ) {
		// There was no session checking here - consider to add something
	}

	String pathInfo = request.getParameter( "f" );
	if ( pathInfo == null ) {
		pathInfo = "";
	}
	else {
		// check and remove tag part
		pathInfo = Herpa.stripTag( pathInfo );
	}

	String targetDevice = request.getParameter( "cTargetDevice" );
	// by default frame.jsp requests get redirected to the 'closest child'. 
	boolean closestRedirect = true;
	if ( "no".equals( request.getParameter( "cRedir" ) ) ) {
		// do not redirect the request to the 'closest child' (eg. QV)
		// only to the HUB in case of CWL
		closestRedirect = false;
	}

	String study = null;
	int n = pathInfo.indexOf( "/" );
	if ( n > 0 )
		study = pathInfo.substring( 0, n );

	if ( study == null ) {
		logger.syslog( Syslog.LOG_DEBUG, "Study is null" );
		return;
	}

	//CWL, showimages calling
	String redirURL = null;
	if ( DotcomConfig.selfDevice().isDbOnly() ) {
		if ( targetDevice != null && !"".equals( targetDevice ) ) {
			redirURL = RedirectToolbox.getURL( DotcomConfig.getConfig().getServerNameTowards( targetDevice ), sess.getClientAddress().getHostAddress(), null );
		}
		else {
			redirURL = RedirectToolbox.getClosestRedirectForStudy( sess, study );
		}
	} 
	else {
		if( closestRedirect ) {
			try {
				if( new Frame( pathInfo, false ).getImageQualifier().startsWith( "r" ) ) {
					closestRedirect = false;
					// don't redirect key images
				}
			}
			catch ( Throwable th ) {
				Helper.ERRORLOG( "Parsing frame "+pathInfo+" caused: "+Helper.toString( th ) );
			}
		}
		String redirHost = closestRedirect ? RedirectToolbox.getClosestRedirectHostForStudy( sess, study ) : null;
		if ( redirHost != null ) {
			redirURL = RedirectToolbox.getClosestRedirectForStudy( sess, study );
		}
	}
	if ( redirURL != null ) {
		redirURL += "/cases/frame.jsp?" + request.getQueryString();
		if (request.getParameter( RequestConsts.QUERYSTRING_PARENT_SESSION_ID_NAME ) == null ) {
			redirURL += "&"+RequestConsts.QUERYSTRING_PARENT_SESSION_ID_NAME+"="+sess.getSessionId();
		}

		if ( referrerHost != null ) {
			response.addHeader( "TargetURL", redirURL );
			response.addHeader( "Access-Control-Expose-Headers", "TargetURL" );
			response.getOutputStream().print( "<REDIRECT/>" );
		}
		else {
			response.sendRedirect( redirURL );
		}
		return;
	}

	/* proxy kikotve, amugy is false-ot adott vissza - Gabor said, ez nem kell itt! */
//	if ( ProxyToolbox.checkAndProxy( sess, study, true ) ) {
//		logger.syslog( Syslog.LOG_DEBUG, "checkAndProxy is true" );
//		return;
//	}

	logger.syslog( Syslog.LOG_DEBUG, "Create Response" );

	String fname = "";

	// check if the image exists and create it if doesn't exist
	try {
		boolean bReprocess = request.getHeader( "PBReprocess" ) != null;
		logger.syslog( Syslog.LOG_DEBUG, "Reprocess flag: " + bReprocess );

		Frame image = new Frame( pathInfo, bReprocess );
		
		
		if ( pathInfo.endsWith(".cw4") || pathInfo.endsWith(".ei4") ) {
			
			byte[] cmpbytes = image.getCW4StreamFromBlob();
						
			response.setContentType( "application/octet-stream" );
			response.setHeader( "Content-Transfer-Encoding", "8bit" );
			response.setCharacterEncoding( "ISO-8859-1" );

			response.setContentLength( cmpbytes.length );
			
			ServletOutputStream os = response.getOutputStream();
			os.write( cmpbytes );
			os.flush();
			os.close();
			
			return;
		}
		

		if ( pathInfo.endsWith( ".cw1" ) ) {
			throw new Exception( "CW1 compression is no longer supported" );
		}
		
		fname = image.getImageFileName();
		image.checkAndCreateImage();
	}
	catch ( TimeoutException th ) {
		response.setStatus(408);
		response.setHeader( "Content-type", "text/html" );
		String msg = "<HTML>\n<HEAD><TITLE>ERROR</TITLE></HEAD><BODY><H2>File " + fname + " processing timeout...</H2><BR><pre>" +
				th.getMessage() + "</pre></BODY>\n</HTML>\n";
		response.setHeader( "Content-length", Integer.toString( msg.length() ) );
		out.print( msg );
		return;
	}
	catch ( Throwable th ) {
		response.setStatus(404);
		response.setHeader( "Content-type", "text/html" );
		String msg = "<HTML>\n<HEAD><TITLE>ERROR</TITLE></HEAD><BODY><H2>File " + fname + " not found...</H2><BR><pre>" +
				th.getMessage() + "</pre></BODY>\n</HTML>\n";
		response.setHeader( "Content-length", Integer.toString( msg.length() ) );
		out.print( msg );
		return;
	}

	response.setContentType( "image/jpeg" );

	Range range = new Range( request, response );

	try {
		range.sendRequestedRange( fname );
	}
	catch ( Throwable t1 ) {
		// not found or other I/O error
		response.setStatus(404);
	}

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>