<%--
 * Component: cases
 *
 * Description:
 *  Interface for saving reports used by the viewer and remote dotcom servers.
 *
 * Parameters (multipart):
 *
 *   cLogFile     Crash log file
 *
--%><%@
page import="com.erad.pacs.toolbox.UserRequestResponseToolbox"%><%@
	page import="java.io.*, java.util.*,
		com.erad.pacs.connector.Connector,
		com.erad.pacs.services.usermanager.client.Session,
		com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
		imagemed.imsession.*,
		imagemed.util.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	/**
	 * Adds log files uploaded by the viewer to vewer info log file.
	 *
	 * @param is        Session for original request headers
	 * @param mr        Multipart request having the uploaded files
	 * @param logFile   Path to the viewer info log file
	 *
	 * @throws IOException if an I/O error occurs
	 */
	static synchronized void addToViewerLog(HttpServletRequest request, MultipartRequest mr, String logFile) throws IOException {
		BufferedWriter bw = new BufferedWriter(new FileWriter(logFile, true)); // open file in append mode
		
		bw.write("@@@ ");
		bw.write(Helper.getTimeDate());
		bw.write(" Viewer Info");
		bw.newLine();
		String viewerAgent = request.getHeader("ViewerAgent");
		String viewerVersion = request.getHeader("ViewerVersion");
		String viewerClient = request.getHeader("ViewerClient");
		bw.write("### ViewerAgent: ");
		bw.write(viewerAgent == null ? "Unrecognized" : viewerAgent);
		bw.newLine();
		bw.write("### ViewerVersion: ");
		bw.write(viewerVersion == null ? "Unrecognized" : viewerVersion);
		bw.newLine();
		bw.write("### ViewerClient: ");
		bw.write(viewerClient == null ? "Unrecognized" : viewerClient);
		bw.newLine();

		for (Enumeration<String> e = mr.getParameterNames(); e.hasMoreElements();) {
			String parName = e.nextElement();
			String parVals[] = mr.getParameterValues(parName);
			if (parVals == null)
				continue;
			for (int i = 0 ; i < parVals.length ; i++) {
				bw.write("### ");
				bw.write(parName);
				bw.write("[" + i + "]");
				bw.newLine();

				char buf[] = new char[2048];
				int nRead = -1;
				FileReader fr = new FileReader(parVals[i]);
				while (-1 < (nRead = fr.read(buf))) {
					bw.write(buf, 0, nRead);
				}
				fr.close();
				bw.newLine();
			}
		}

		bw.close();
	}

%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = UserRequestResponseToolbox.getSessitaSessionNoSessParCheck( request, response );
	
	try ( MultipartRequest mp = new MultipartRequest( request, IMEnvBase.getEnv( "TMP" ) ) ) {
		addToViewerLog( request, mp, IMEnvBase.getEnv( "LOG" ) + "/viewerinfo.log" );
	}

%>OK<%

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>
