<%-- 
 * Component: cases
 *
 * Description:
 *   Quick View Window to show a DICOM image
 
 *   Quick View Window has got two parts (frames).
 *   The top is the quick view.
 *   The bottom contains DICOM dump links.
 *
 * Params:
 *    cFileName - File Name of the object to show
 *    cI          Frame Number within the object
 *    cX          Maximum X size
 *    cY          Maximum Y size
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%>
<%@page import="com.erad.pacs.store.EPDBConnector"%>
<%@page import="com.erad.pacs.store.SmartPreparedStatement"%>
<%@page import="com.erad.pacs.toolbox.UserRequestResponseToolbox"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@
	page errorPage="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.util.Helper,imagemed.types.*,java.sql.*,imagemed.imsession.*,imagemed.jsputil.RedirectToolbox"

%><%!
	String sanitize(String str){ 
	if (str == null){
		return null;
	}
	return str.replaceAll( "\"", "&quot;" ).replaceAll( "'", "&#x27;" ).replaceAll( "<", "&lt;" ).replaceAll( ">", "&gt;" );
}
%><%
UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = UserRequestResponseToolbox.getSessitaSessionNoSessParCheck( request, response );

	boolean hasDumpRight = sess.getRights().hasRight( PacsRight.Dump );

	String cI = sanitize(request.getParameter( "cI" ));
	String cX = sanitize(request.getParameter( "cX" ));
	String cY = sanitize(request.getParameter( "cY" ));
	String type = sanitize(request.getParameter( "type" ));

	String fileName = request.getParameter( "cFile" );
	String study = request.getParameter( "cStudy" );
	
	String redirHost = RedirectToolbox.getRedirectForStudy( sess, study );
	if ( redirHost != null ) {
		String redirURL = redirHost + "/cases/qvwin.jsp?" + RedirectToolbox.getRedirectParams( sess, request );
		response.sendRedirect( redirURL );
		return;
	}
	
	UserRequestResponseToolbox.checkSessionIdParamsAndRedirect( request, response ); // if we don't redirect to another server hide session from URL
	
	String pName = null;
	try ( SmartPreparedStatement sps = EPDBConnector.getCachedSps( "SELECT PNAME FROM Dcstudy WHERE STYIUID=?" ) ) {
		sps.setStringArg( 1, study );
		try ( ResultSet res = sps.executeQuery() ) {
	res.next();
	pName = res.getString( "PNAME" );
		}
	}

	String patientName = IMType.getTypeFor( "PN" ).display( sess, pName );

	String frameSetRows = hasDumpRight ? "*,48" : "*";
%><HEAD>
<TITLE><%=patientName%></title>
</head>

<FRAMESET rows="<%=frameSetRows%>" frameborder=no frameborder="0" border=0 framespacing=0>

<FRAME src="qvwintop.jsp?study=<%= study %>&fileName=<%= fileName %>&cI=<%= cI %>&cX=<%= cX %>&cY=<%= cY %>&type=<%= type %>"
		noresize marginwidth=0 marginheight=0>

<%
	if ( hasDumpRight ) {
%>

<FRAME src="qvwinbot.jsp?cStudy=<%= study %>&cFname=<%= fileName %>&pName=<%= Helper.URLEncodeUTF8( patientName ) %>"
		noresize marginwidth=0 marginheight=0>
<%
	}
%>

</frameset>