<%--
 * Component: cases
 *
 * Description:
 *    Saves the viewer profile for a user.
 *
 * Parameters:
 * 
 *     USERNAME : ID of the user for the profile to be saved
 *     PROFILE  : profile data to be saved
 *
--%><%@
	page import="java.io.*,java.util.*,
			com.erad.pacs.connector.Connector,
			com.erad.pacs.services.usermanager.client.Session,
			com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
			com.erad.pacs.toolbox.UserRequestResponseToolbox,
			com.erad.pacs.services.settings.service.toolbox.ViewerProfileToolbox,
			com.erad.pacs.modules.gwt.descriptors.settings.user.profile.UserType,
			com.erad.pacs.viewer.reader.ProfileReader,
			com.erad.rmisubstitute.call.proliferate.ProliferateFileResource.ProliferateMode,
			com.erad.pacs.toolbox.ChecksumToolbox,
			com.erad.pacs.viewer.XmlRoutines,
			imagemed.util.Helper, imagemed.imsession.*, imagemed.jsputil.*, imagemed.users.*"

%><% 

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = UserRequestResponseToolbox.getSessitaSessionNoSessParCheck( request, response );
	
	String strResponse = "ERROR: User not found";
	String strUserName = request.getParameter( "USERNAME" );
	String strProfileData = request.getParameter( "PROFILE" );
	String strRegCookie = sess.getSessionId(  );
	String strViewerChecksum = request.getParameter( "CHECKSUM" );

	if ( strUserName == null ) {
		strUserName = sess.getUser().getUserId();
	}

	String strChecksumToSend = "";
	try {
		// get the user part of the user viewer profile xml of the server
		String strUserPartServerXml = XmlRoutines.getViewerProfileUserPart( sess );
		String strServerChecksum = ChecksumToolbox.createChecksumHexString( strUserPartServerXml );
		strChecksumToSend = strServerChecksum;
		if ( strViewerChecksum != null && !ChecksumToolbox.equals( strServerChecksum, strViewerChecksum ) ) {
			// the viewer sent a checksum but it doesn't match with the current server checksum -> refuse to save profile
			strResponse = "ERROR: Checksum mismatch";
			Helper.ERRORLOG( "Viewer profile save attempt failed with checksum mismatch error. UserId=" + strUserName + 
					" SessionId=" + strRegCookie + 
					" HostAddress=" + sess.getClientAddress().getHostAddress() );
		} else if ( strUserName != null && strRegCookie != null ) {
			// write changed profile and manage backup files
			ProfileReader.write( UserType.USER, strUserName, strProfileData );
			// new profile successfully saved, create the new checksum
			strUserPartServerXml = XmlRoutines.getViewerProfileUserPart( sess );
			strChecksumToSend = ChecksumToolbox.createChecksumHexString( strUserPartServerXml );

			ViewerProfileToolbox.proliferateViewerProfile( sess, UserType.USER, strUserName );

			strResponse = "OK";
		}
	}
	catch ( Throwable th ) {
		strResponse = "ERROR: Profile could not be saved";
	}


	response.setContentType( "text/plain" );
	response.setHeader( "Pragma","no-cache" );

	// add viewer profile checksum information SRV-1237
	response.setHeader( "ViewerProfileChecksum", strChecksumToSend );
		
	out.println( "# SessionID: " + strRegCookie );
	out.println( "# Profile: " + strResponse );

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>
